library contact_v2;

import 'package:sunny_sdk_core/model_exports.dart';
import 'package:sunny_service_stubs/models/contact_v2/contact_v2.dart';

import 'model/contact_info.dart';
import 'model/contact_list.dart';
import 'model/note_list.dart';
import 'model/physical_location.dart';
import 'model/task_list.dart';

export 'package:sunny_service_stubs/models/contact_v2/contact_v2.dart';

export 'api/contact_api.dart';
export 'api/note_api.dart';
export 'api/task_api.dart';
export 'ext/ext.dart';
export 'model/contact.dart';
export 'model/contact_info.dart';
export 'model/contact_list.dart';
export 'model/note.dart';
export 'model/note_list.dart';
export 'model/physical_location.dart';
export 'model/task.dart';
export 'model/task_list.dart';

const contactModuleRef = MModuleRef.ofParts("mverse", "contact", "0.0.1");

registerContact_v2Models(
    MModelRegistry modelRegistry, MEnumRegistry enumRegistry) {
  modelRegistry.register(
      ContactRef,
      (json) =>
          throw Exception("Unable to instantiate abstract entity $ContactRef"));

  modelRegistry.register(
      ContactInfoRef, (json) => ContactInfo(json as Map<String, dynamic>));
  IContactInfo.of = ContactInfo.of;
  IContactInfo.fromJson = ContactInfo.fromJson;

  modelRegistry.register(
      ContactListRef, (json) => ContactList(json as Map<String, dynamic>));
  IContactList.of = ContactList.of;
  IContactList.fromJson = ContactList.fromJson;

  modelRegistry.register(
      NoteRef,
      (json) =>
          throw Exception("Unable to instantiate abstract entity $NoteRef"));

  modelRegistry.register(
      NoteListRef, (json) => NoteList(json as Map<String, dynamic>));
  INoteList.of = NoteList.of;
  INoteList.fromJson = NoteList.fromJson;

  modelRegistry.register(PhysicalLocationRef,
      (json) => PhysicalLocation(json as Map<String, dynamic>));
  IPhysicalLocation.of = PhysicalLocation.of;
  IPhysicalLocation.fromJson = PhysicalLocation.fromJson;

  modelRegistry.register(
      TaskRef,
      (json) =>
          throw Exception("Unable to instantiate abstract entity $TaskRef"));

  modelRegistry.register(
      TaskListRef, (json) => TaskList(json as Map<String, dynamic>));
  ITaskList.of = TaskList.of;
  ITaskList.fromJson = TaskList.fromJson;
}
